# Debug

Administrative debug endpoints.

## Get debug information

`GET /api/v1/server/debug`

Retrieve internal debug information for administrators.

Authentication (security requirement alternatives):

```json
[
  {
    "OAuth2": [
      "admin"
    ]
  }
]
```

- OAuth2: oauth2. Authenticating via OAuth requires the following steps:
- Have an activated account
- [Generate] an access token for that account at `/api/v1/users/token`.
- Make requests with the *Authorization: Bearer <token\>* header
- Profit, depending on the role assigned to the account

Note that the __access token is valid for 1 day__ and is given
along with a __refresh token valid for 2 weeks__.

[Generate]: https://docs.joinpeertube.org/api/rest-getting-started
; scopes: admin

Responses:

- 200: successful operation

Content type: application/json

Type: object

- `ip` (optional)
  Type: string

- `activityPubMessagesWaiting` (optional)
  Type: integer

- `secondariesUp` (optional)
  Type: integer
  
  Number of secondary processes that recently sent a heartbeat

- `processes` (optional)
  Type: Array<object>
  
  Processes of the platform that recently sent a heartbeat, the primary first
  
  Items:
    Type: object
    
    - `id` (optional)
      Type: string
    
    - `role` (optional)
      Type: string
      
      enum: ["primary","secondary"]
    
    - `hostname` (optional)
      Type: string
    
    - `pid` (optional)
      Type: integer
    
    - `version` (optional)
      Type: string
    
    - `startedAt` (optional)
      Type: string, date-time
      
      When the process started to serve requests
    
    - `lastSeenAt` (optional)
      Type: string, date-time

## Examples

### cURL

```bash
curl -X GET 'https://peertube2.cpy.re/api/v1/server/debug' \
  -H 'Authorization: Bearer YOUR_TOKEN'
```

### JavaScript

```javascript
const response = await fetch('https://peertube2.cpy.re/api/v1/server/debug', {
  method: 'GET',
  headers: {
    'Authorization': 'Bearer YOUR_TOKEN',
  },
});

const data = await response.text();
```

### Python

```python
import requests

response = requests.get(
    'https://peertube2.cpy.re/api/v1/server/debug',
    headers={
        'Authorization': 'Bearer YOUR_TOKEN',
    },
)
print(response.text)
```


## Run a debug command

`POST /api/v1/server/debug/run-command`

Run an internal debug command as an administrator.

Authentication (security requirement alternatives):

```json
[
  {
    "OAuth2": [
      "admin"
    ]
  }
]
```

- OAuth2: oauth2. Authenticating via OAuth requires the following steps:
- Have an activated account
- [Generate] an access token for that account at `/api/v1/users/token`.
- Make requests with the *Authorization: Bearer <token\>* header
- Profit, depending on the role assigned to the account

Note that the __access token is valid for 1 day__ and is given
along with a __refresh token valid for 2 weeks__.

[Generate]: https://docs.joinpeertube.org/api/rest-getting-started
; scopes: admin

Request body: application/json (required)

Type: object

oneOf:
  Type: object
  
  - `command` (required)
    Type: string
    
    enum: ["remove-dandling-resumable-uploads","remove-expired-user-exports","process-video-stats-buffer","process-video-viewers","process-update-videos-scheduler","process-video-channel-sync-latest","process-remove-old-stats","process-video-files-lifecycle"]

  Type: object
  
  - `command` (required)
    Type: string
    
    enum: ["test-emails"]
  
  - `email` (required)
    Type: string, email

Responses:

- 204: successful operation

- 400: invalid command or invalid email

## Examples

### cURL

```bash
curl -X POST 'https://peertube2.cpy.re/api/v1/server/debug/run-command' \
  -H 'Authorization: Bearer YOUR_TOKEN' \
  -H 'Content-Type: application/json' \
  --data-raw '{
  "command": "remove-dandling-resumable-uploads"
}'
```

### JavaScript

```javascript
const body = `{
  "command": "remove-dandling-resumable-uploads"
}`;

const response = await fetch('https://peertube2.cpy.re/api/v1/server/debug/run-command', {
  method: 'POST',
  headers: {
    'Authorization': 'Bearer YOUR_TOKEN',
    'Content-Type': 'application/json',
  },
  body,
});

const data = await response.text();
```

### Python

```python
import requests

body = '''{
  "command": "remove-dandling-resumable-uploads"
}'''

response = requests.post(
    'https://peertube2.cpy.re/api/v1/server/debug/run-command',
    data=body.encode('utf-8'),
    headers={
        'Authorization': 'Bearer YOUR_TOKEN',
        'Content-Type': 'application/json',
    },
)
print(response.text)
```
